<?php if(!defined('PLX_ROOT')) exit; 
	
	/**
		* Plugin 			plxNotifyMe
		*
		* @CMS required		PluXml 
		* @page				admin.php
		* @version			1.2
		* @date				08/02/2025
		* @author 			gcyrillus
		░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
		░       ░░  ░░░░░░░  ░░░░  ░  ░░░░  ░░      ░░       ░░░      ░░  ░░░░░░░        ░░      ░░░░░   ░░░  ░        ░        ░
		▒  ▒▒▒▒  ▒  ▒▒▒▒▒▒▒  ▒▒▒▒  ▒▒  ▒▒  ▒▒  ▒▒▒▒  ▒  ▒▒▒▒  ▒  ▒▒▒▒  ▒  ▒▒▒▒▒▒▒▒▒▒  ▒▒▒▒  ▒▒▒▒▒▒▒▒▒▒    ▒▒  ▒  ▒▒▒▒▒▒▒▒▒▒  ▒▒▒▒
		▓       ▓▓  ▓▓▓▓▓▓▓  ▓▓▓▓  ▓▓▓    ▓▓▓  ▓▓▓▓  ▓       ▓▓  ▓▓▓▓  ▓  ▓▓▓▓▓▓▓▓▓▓  ▓▓▓▓▓      ▓▓▓▓▓  ▓  ▓  ▓      ▓▓▓▓▓▓  ▓▓▓▓
		█  ███████  ███████  ████  ██  ██  ██  ████  █  ███████  ████  █  ██████████  ██████████  ████  ██    █  ██████████  ████
		█  ███████        ██      ██  ████  ██      ██  ████████      ██        █        ██      ██  █  ███   █        ████  ████
		█████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████
	**/	
	# Control du token du formulaire
	plxToken::validateFormToken($_POST);
	
	# Liste des langues disponibles et prises en charge par le plugin
	$aLangs = array($plxAdmin->aConf['default_lang']);
	
	# abonnés
	$subscription= $plxPlugin->getJsonDatas(PLX_ROOT.'plugins/'.$plugin.'/'.$plxPlugin->subscriptions.'/'.$plxPlugin->subscriptions.'.json');
	$valid=$invalid=$nbSub=0;
	
	if(is_array($subscription)) {
		$nbSub =  count($subscription);
		forEach($subscription as $k=>$v) {
			if ($v['valid']==1) $valid++;
			else $invalid++;
		} 	
	}
	
	# statistiques receuillies
	$stats = $plxPlugin->getJsonDatas(PLX_ROOT.'plugins/'.$plugin.'/'.$plxPlugin->subscriptions.'/infosStat.json');
	# details
	$sent = $stats['sent'];
	$retours = $stats['retour'];
	$defec = $stats['defec'];
	$cleaned = $stats['unset'];
	$date = $plxPlugin->timeToLocalDate($stats['lastDate']);


	# effacer un abonné
	if(isset($_GET['stopNewsLetter'])) {
		$plxPlugin->revoque();
		exit;
	}
	
	# ajout d'un abonné
	if(isset($_GET['addSubscriber'])) {
		$plxPlugin->setParam('method','get','string');
		$plxPlugin->addSubscriber();	
	}
?>
<div id="topAdmin">
	<!-- lien retour vers l'admin -->
	<a href="<?php echo PLX_ROOT ?>core/admin/"   title="<?php $plxPlugin->lang('L_BACK_TO_ADMINISTRATION') ?>"> <?php $plxPlugin->lang('L_BACK_TO_ADMINISTRATION') ?> </a>
	<!-- lien direct vers la page de configuration -->
	<p style="text-align:right;text-align:inline-end;margin-inline-end:1em;"><!-- --> <a href="<?php echo PLX_ROOT ?>core/admin/parametres_plugin.php?p=<?= $plugin ?>"  title="<?php $plxPlugin->lang('L_GOTO_CONFIG') ?>"><?php $plxPlugin->lang('L_CONFIG') ?></a></p>
	<form action="plugin.php?p=<?= $plugin ?>" method="post" id="form_<?= $plugin ?>">
		<div id="onglets">
			<div class="onglet " data-title="<?php $plxPlugin->lang('L_STATISTICS') ?>">
			<?php
			if($sent +	$retours +	$defec + $cleaned == 0) echo $plxPlugin->lang('L_NO_DATAS');
			?>
				<script src='https://cdn.plot.ly/plotly-2.35.2.min.js'></script>	
				<div style="display:inline-block;vertical-align:bottom;" id="myNewsStat"></div>
				<div style="display:inline-block;vertical-align:bottom;" id="myPie"></div>
				<script>
					const x = ["<?php $plxPlugin->lang('L_SUBSCRIPTION') ?>"]
					var trace1 = {
						name: "<?= $plxPlugin->getLang('L_SUBSCRIPTION') ?>",
						x,
						y: [<?php echo $nbSub ?>],
						type: "bar",
						legendgroup: "Notifications",
						marker: { color: "gold" }
					};		
					var trace2 = {
						name: "<?= $plxPlugin->getLang('L_UNSUBSCRIBERS') ?>",
						x,
						y: [<?php echo $defec  ?>],
						type: "bar",
						legendgroup: "Notifications",
						marker: { color: "#f11d28" }
					};
					var trace3 = {
						name: "<?= $plxPlugin->getLang('L_SUBSCRIBED') ?>",
						x,
						y: [<?php echo $valid ?>],
						type: "bar",
						legendgroup: "Notifications",
						marker: { color: "#068775" }
					};
					var trace4 = {
						name: "<?= $plxPlugin->getLang('L_DEL_SUBSCRIBERS') ?>",
						x,
						y: [<?php echo $cleaned ?>],
						type: "bar",
						legendgroup: "Notifications",
						marker: { color: "#0366" }
					};
					var trace5 = {
						name: "<?= $plxPlugin->getLang('L_PENDING_SUBSCRIBERS') ?>",
						x,
						y: [<?php echo $nbSub - $valid ?>],
						type: "bar",
						legendgroup: "Notifications",
						marker: { color: "#FFA12C" }
					};
					
					var data = [trace1, trace3, trace2, trace4,trace5];
					var layout = {
						height: 400,
						width: 500,
						barmode: "group",
						title: "<?php $plxPlugin->lang('L_STATISTICS') ?>",
						xaxis: { title: "<?php $plxPlugin->lang('L_STATISTICS') ?> <?php $plxPlugin->lang('L_SUBSCRIBERS') ?>", type: "text" }
					};
					Plotly.newPlot("myNewsStat", data, layout);
					
					var piedata = [{
						values: [<?php echo $sent ?>,<?php echo $retours ?>,0],
						labels: ['<?= $plxPlugin->getLang('L_NEWS_SENT') ?>', '<?= $plxPlugin->getLang('L_FEEDBACK') ?>','<?= $plxPlugin->getLang('L_LAST_SEND') ?>  <?php 
							
							echo 
							'<br><b>'.$date.'</b>';
						?>'],
						marker: {
							colors: ['#3498DB', '#5FD797','crimson']
						},
						title: '<?php $plxPlugin->lang('L_STATISTICS') ?> <?php $plxPlugin->lang('L_NEWS_SENT') ?>',
						titleposition: 'bottom center',
						
						type: 'pie'
					}];
					
					var pielayout = {
						height: 400,
						width: 500,
						font: {
							size: 15
						},
						margin: { t: 60, b: 10, l: 0, r: 0 }
					};
					
					
					Plotly.newPlot('myPie', piedata, pielayout);
				</script>
				<style>g.slicetext:has(text.slicetext[data-unformatted="0%"]) {
					display:none
					}
				</style>
			</div>
			<div class="onglet" data-title="<?php $plxPlugin->lang('L_SUBSCRIBERS') ?>">
				<?php $plxPlugin->getsubscribers(); ?>
			</div>
		</div>
	</form>
</div>	
<?php	echo '<script src="'.PLX_ROOT.'plugins/'.basename(__DIR__).'/js/onglets.js"></script>'.PHP_EOL;				