<?php
	/**
		* Plugin 			plxNotifyMe
		*
		* @CMS required		PluXml 
		* @version			1.2
		* @date				08/02/2025
		* @author 			gcyrillus
		░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░░
		░       ░░  ░░░░░░░  ░░░░  ░  ░░░░  ░░      ░░       ░░░      ░░  ░░░░░░░        ░░      ░░░░░   ░░░  ░        ░        ░
		▒  ▒▒▒▒  ▒  ▒▒▒▒▒▒▒  ▒▒▒▒  ▒▒  ▒▒  ▒▒  ▒▒▒▒  ▒  ▒▒▒▒  ▒  ▒▒▒▒  ▒  ▒▒▒▒▒▒▒▒▒▒  ▒▒▒▒  ▒▒▒▒▒▒▒▒▒▒    ▒▒  ▒  ▒▒▒▒▒▒▒▒▒▒  ▒▒▒▒
		▓       ▓▓  ▓▓▓▓▓▓▓  ▓▓▓▓  ▓▓▓    ▓▓▓  ▓▓▓▓  ▓       ▓▓  ▓▓▓▓  ▓  ▓▓▓▓▓▓▓▓▓▓  ▓▓▓▓▓      ▓▓▓▓▓  ▓  ▓  ▓      ▓▓▓▓▓▓  ▓▓▓▓
		█  ███████  ███████  ████  ██  ██  ██  ████  █  ███████  ████  █  ██████████  ██████████  ████  ██    █  ██████████  ████
		█  ███████        ██      ██  ████  ██      ██  ████████      ██        █        ██      ██  █  ███   █        ████  ████
		█████████████████████████████████████████████████████████████████████████████████████████████████████████████████████████
	**/	
	class plxNotifyMe extends plxPlugin {
		const BEGIN_CODE = '<?php' . PHP_EOL;
		const END_CODE = PHP_EOL . '?>';
		public $url = ''; # parametre de l'url pour accèder à la page statique
		public $lang = '';
		public $mailIPT = '';
		public $subscriptions ;
		public $nbSubscriptions ;
		public $revoque;
		public $lots = 1;
		
		/**
			* Constructeur de la classe
			*
			* @param	default_lang	langue par défaut
			* @return	stdio
			* @author	Stephane F
		**/
		public function __construct($default_lang) {
			
			# gestion du multilingue plxMyMultiLingue
			$this->lang='';
			if(defined('PLX_MYMULTILINGUE')) {
				$lang = plxMyMultiLingue::_Lang();
				if(!empty($lang)) {
					if(isset($_SESSION['default_lang']) AND $_SESSION['default_lang']!=$lang) {
						$this->lang = $lang.'/';
					}
				}
			}		
			
			# appel du constructeur de la classe plxPlugin (obligatoire)
			parent::__construct($default_lang);
			
			$this->url = $this->getParam('url')=='' ? 'NewsLetter' : $this->getParam('url');
			if(file_exists(PLX_PLUGINS.basename(__DIR__).'/activated.php')) include(PLX_PLUGINS.basename(__DIR__).'/activated.php');
			# droits pour accèder à la page config.php du plugin
			$this->setConfigProfil(PROFIL_ADMIN);
			
			# droits pour accèder à la page admin.php du plugin
			$this->setAdminProfil(PROFIL_ADMIN);
			
			# déclaration des hooks
			$this->addHook('AdminTopEndHead', 'AdminTopEndHead');
			$this->addHook('AdminTopBottom', 'AdminTopBottom');
			$this->addHook('plxAdminHtaccess', 'plxAdminHtaccess');	
			$this->addHook('plxAdminEditArticleEnd','plxAdminEditArticleEnd');
			
			# Si le fichier de langue existe on peut mettre en place la partie visiteur
			if(file_exists(PLX_PLUGINS.$this->plug['name'].'/lang/'.$default_lang.'.php')) {
				$this->addHook('plxShowConstruct', 'plxShowConstruct');
				$this->addHook('plxMotorPreChauffageBegin', 'plxMotorPreChauffageBegin');
				$this->addHook('plxShowStaticListEnd', 'plxShowStaticListEnd');
				$this->addHook('plxShowPageTitle', 'plxShowPageTitle');
				$this->addHook('SitemapStatics', 'SitemapStatics');
				$this->addHook('NotifyMeForm', 'form');
				if(defined('PLX_MYMULTILINGUE')) {
					$this->addHook('ThemeEndHead', 'ThemeEndHead');
				}			
			}
			$this->lots = $this->getParam('batch')=='' ? $this->lots : $this->getParam('batch'); 
		}
		
		# code à exécuter à l’activation du plugin 
		# creer une variable aleatoire pour le dossier et fichier de stockage des abonnements.
		# @author G.Cyrille
		public function OnActivate() { 
			# verifie la presence du fichier d'initialisation
			$initFile=PLX_PLUGINS.basename(__DIR__).'/activated.php';
			$importFile = PLX_PLUGINS.'MyNewsLetter/activated.php';
			if(!file_exists($initFile)) {
				# importation des abonnés de MyNewsLetter
				if(file_exists($importFile)&& copy($importFile, $initFile )){
					include($initFile);
					mkdir(PLX_PLUGINS.basename(__DIR__).'/'.$this->subscriptions, 0775);	
					touch(PLX_PLUGINS.basename(__DIR__).'/'.$this->subscriptions.'/index.html');
					copy(PLX_PLUGINS.'MyNewsLetter/'.$this->subscriptions.'/'.$this->subscriptions.'.json',PLX_PLUGINS.basename(__DIR__).'/'.$this->subscriptions.'/'.$this->subscriptions.'.json');
				}
				else {
					#création d'un nom de repertoire aléatoire
					$subscriptionDir=bin2hex(random_bytes('16'));// php7 au minimum!!!!
					#création du contenu du fichier d'initialisation
					$file_content='<?php if(!defined(\'PLX_ROOT\')) exit;'.PHP_EOL.'$this->subscriptions =\''.$subscriptionDir.'\';';
					#ecriture du fichier
					if (!touch($initFile)) {
						echo "erreur";
						} else {
						file_put_contents($initFile, $file_content);
					}
					chmod($initFile, 0600);
					#création du repertoire dans le plugin
					mkdir(PLX_PLUGINS.basename(__DIR__)."/".$subscriptionDir, 0775);	
					touch(PLX_PLUGINS.basename(__DIR__)."/".$subscriptionDir."/index.html");
					include $initFile;
				}
			}
			# on verifie nos repertoires et on crée les fichiers manquants
			if (!file_exists(PLX_PLUGINS.basename(__DIR__).'/'.$this->subscriptions.'/'.$this->subscriptions.'.json')) {
				file_put_contents(PLX_PLUGINS.basename(__DIR__).'/'.$this->subscriptions.'/'.$this->subscriptions.'.json','[]');
			}
			$infostats ='{"sent": 0,"retour": 0,"defec": 0,"unset": 0,"lastDate": 0}';
			if (!file_exists(PLX_PLUGINS.basename(__DIR__).'/'.$this->subscriptions.'/infosStat.json')) {
				file_put_contents(PLX_PLUGINS.basename(__DIR__).'/'.$this->subscriptions.'/infosStat.json',$infostats );
			}
		}
		
		/**
			* Méthode qui mets à jour le fichier .htaccess du site pour prendre en charge $_GET dans le traitement du formulaire
			*
			* @return	stdio
			* @author	Stephane F
		**/
		public function plxAdminHtaccess() {	
			echo '<?php	$htaccess = str_replace("[L]", "[QSA,L]", $htaccess); ?>';	
		}
		
		/**
			* Méthode qui charge le code css nécessaire à la gestion de onglet dans l'écran de configuration du plugin
			*
			* @return	stdio
			* @author	Stephane F
		**/
		public function AdminTopEndHead() {
			
		    $this->plxAdminEditArticleEnd();
			if(basename($_SERVER['SCRIPT_NAME'])=='parametres_plugin.php') {
				echo '<link href="'.PLX_PLUGINS.$this->plug['name'].'/tabs/style.css" rel="stylesheet" type="text/css" />'."\n";
			}
		}
		
		/**
			* Méthode qui affiche un message si le plugin n'a pas la langue du site dans sa traduction
			*
			* @return	stdio
			* @author	Stephane F
		**/
		public function AdminTopBottom() {	
			echo '<?php
			$file = PLX_PLUGINS."'.$this->plug['name'].'/lang/".$plxAdmin->aConf["default_lang"].".php";
			if(!file_exists($file)) {
			echo "<p class=\"warning\">Plugin NotifyMe<br />".sprintf("'.$this->getLang('L_LANG_UNAVAILABLE').'", $file)."</p>";
			plxMsg::Display();
			}
			?>';
		}
		
		/**
			* Méthode de traitement du hook plxShowConstruct
			*
			* @return	stdio
			* @author	Stephane F
		**/
		public function plxShowConstruct() {
			# infos sur la page statique
			$string  = "if(\$this->plxMotor->mode=='".$this->url."') {";
			$string .= "	\$array = array();";
			$string .= "	\$array[\$this->plxMotor->cible] = array(
			'name'		=> '".$this->getParam('mnuName_'.$this->default_lang)."',
			'menu'		=> '',
			'url'		=> 'NotifyMe',
			'readable'	=> 1,
			'active'	=> 1,
			'group'		=> ''
			);";
			$string .= "	\$this->plxMotor->aStats = array_merge(\$this->plxMotor->aStats, \$array);";
			$string .= "}";
			echo "<?php ".$string." ?>";
		}
		
		/**
			* Méthode de traitement du hook plxMotorPreChauffageBegin
			*
			* @return	stdio
			* @author	Stephane F
		**/
		public function plxMotorPreChauffageBegin() {			
			$template = $this->getParam('template')==''?'static.php':$this->getParam('template');			
			$string = "
			if(\$this->get && preg_match('/^".$this->url."\/?/',\$this->get)) {
			\$this->mode = '".$this->url."';
			\$prefix = str_repeat('../', substr_count(trim(PLX_ROOT.\$this->aConf['racine_statiques'], '/'), '/'));
			\$this->cible = \$prefix.\$this->aConf['racine_plugins'].'plxNotifyMe/form';
			\$this->template = '".$template."';
			return true;
			}
			";
			echo "<?php ".$string." ?>";
			# comptabilise les liens depuis une newsletter
			if(isset($_GET['news'])) {$this->record('visit');}	
		}
		
		/**
			* Méthode de traitement du hook plxShowStaticListEnd
			*
			* @return	stdio
			* @author	Stephane F
		**/
		public function plxShowStaticListEnd() {
			# ajout du menu pour accèder à la page de recherche
			if($this->getParam('mnuDisplay')) {
				echo "<?php \$status = \$this->plxMotor->mode=='".$this->url."'?'active':'noactive'; ?>";
				echo "<?php 
				array_splice(\$menus, 
				(".$this->getParam('mnuPos')." - 1), 
				0, 
				'<li class=\"static menu '.\$status.'\" id=\"static-notify\">
				<a href=\"'.\$this->plxMotor->urlRewrite('?".$this->lang.$this->url."')
				.'\" title=\"".$this->getParam('mnuName_'.$this->default_lang)."\">"
				.$this->getParam('mnuName_'.$this->default_lang)."</a></li>');
				?>";
			}
		}
		
		/**
			* Méthode qui renseigne le titre de la page dans la balise html <title>
			*
			* @return	stdio
			* @author	Stephane F
		**/
		public function plxShowPageTitle() {
			echo '<?php
			if($this->plxMotor->mode == "'.$this->url.'") {
			$this->plxMotor->plxPlugins->aPlugins["plxNotifyMe"]->lang("L_PAGE_TITLE");
			return true;
			}
			?>';
		}
		
		/**
			* Méthode qui référence la page de recherche dans le sitemap
			*
			* @return	stdio
			* @author	Stephane F
		**/
		public function SitemapStatics() {
			echo '<?php
			echo "\n";
			echo "\t<url>\n";
			echo "\t\t<loc>".$plxMotor->urlRewrite("?'.$this->lang.$this->url.'")."</loc>\n";
			echo "\t\t<changefreq>monthly</changefreq>\n";
			echo "\t\t<priority>0.8</priority>\n";
			echo "\t</url>\n";
			?>';
		}
		
		/**
			* Méthode statique qui affiche le formulaire de recherche
			*
			* @parm		title		affiche le titre du formulaire si vrai
			* @return	stdio
			* @author	Stephane F
		**/
		public static function form($opt=false) {
			# récupération d'une instance de plxMotor
			$plxMotor = plxMotor::getInstance();
			$plxPlugin = $plxMotor->plxPlugins->getInstance('plxNotifyMe');
			
			if($opt !=false)  $subscribeTo= $plxPlugin->getLang('L_SIDE_FORM_SUBSCRIBE');
			else $subscribeTo = $plxPlugin->getLang('L_FORM_SUBSCRIBE');		
			$method = $plxPlugin->getParam('method') == 'get' ? $_GET : $_POST;
			$frmMethod = $plxPlugin->getParam('method') == 'get' ? 'get' : 'post';
			$placeholder = '';		
			$mail = isset($method['notifyMe']) == '' ? '' : $method['notifyMe'];
			if($plxPlugin->getParam('placeholder_'.$plxPlugin->default_lang)!='') {
				$placeholder=' placeholder="'.$plxPlugin->getParam('placeholder_'.$plxPlugin->default_lang).'"';
			}
		?>
		<div  class="notifyMe">
			<form action="<?php echo $plxMotor->urlRewrite('?'.$plxPlugin->lang.$plxPlugin->getParam('url')) ?>" method="<?php echo $frmMethod ?>">
				<fieldset><legend class="title"><?= $subscribeTo ?></legend>
					<p class="p2col">
						<input type="email" name="notifyMe" id="notifyMe" <?php echo $placeholder ?> value="<?= $mail ?>">
						<input type="submit" class="subscribeMe" value="<?php echo $plxPlugin->getParam('frmLibButton_'.$plxPlugin->default_lang) ?>">
					</p>	
				</fieldset>
			</form>
		</div>
		<?php
		}
		
		/** 
			*
			* Méthode d'ajout des <link rel="alternate"... sur les pages des plugins qui gèrent le multilingue
			*
			* @return	stdio
			* @author	WorldBot
			* 
		**/
		public function ThemeEndHead() {			
			if(defined('PLX_MYMULTILINGUE')) {		
				$plxMML = is_array(PLX_MYMULTILINGUE) ? PLX_MYMULTILINGUE : unserialize(PLX_MYMULTILINGUE);
				$langues = empty($plxMML['langs']) ? array() : explode(',', $plxMML['langs']);
				$string = '';
				foreach($langues as $k=>$v)	{
					$url_lang="";
					if($_SESSION['default_lang'] != $v) $url_lang = $v.'/';
					$string .= 'echo "\t<link rel=\"alternate\" hreflang=\"'.$v.'\" href=\"".$plxMotor->urlRewrite("?'.$url_lang.$this->getParam('url').'")."\" />\n";';
				}
				echo '<?php if($plxMotor->mode=="'.$this->getParam('url').'") { '.$string.'} ?>';
			}
		}	
		
		/**
			* plxAdminEditArticleEnd
			*
			* Declenche l'envoi d'un courriel à la publication d'un article
			*
			* @ $_POST['publish']
			* 
			* @author	GCyrillus
		**/
		public function plxAdminEditArticleEnd(){
			#fichier sauvegarde notification en cours
			$pendingNotification=PLX_ROOT.'plugins/'.__CLASS__.'/'.$this->subscriptions.'/pendingNotification.json';
			$notification='';
			if(isset($_POST['publish']) || file_exists($pendingNotification)){
				# création du fichier si absent
				if(!file_exists($pendingNotification) && isset($_POST['publish'])){
					#recuperation info article
					$url = plxUtils::urlify(!empty($_POST['url']) ? $_POST['url'] : $_POST['title']);
					$plxAdmin = plxAdmin::getInstance();
					$bodyMsg = '
					<h1><a href="'.$plxAdmin->urlRewrite('?article'.intval($_POST['artId']).'/'.$url).'&news">'.plxUtils::cdataCheck(trim($_POST['title'])).'</a></h1>'
					.plxUtils::cdataCheck(trim($_POST['chapo']))
					.plxUtils::cdataCheck(trim($_POST['content']))
					;
					$noticationsDatas['artId'] = trim($_POST['artId']);
					$noticationsDatas['publication'] = $bodyMsg;
					$this->saveJsonDatas($pendingNotification,$noticationsDatas);
				}
				
				# chargement de la notification
				$artNotification = $this->getJsonDatas($pendingNotification);
				
				#notifications envoyés aux abonnés
				$fileNewsSent = PLX_ROOT.'plugins/'.__CLASS__.'/'.$this->subscriptions.'/newsSent.json';
				if(!file_exists($fileNewsSent)) $this->saveJsonDatas($fileNewsSent,array());
				$artNewsPosted = $this->getJsonDatas($fileNewsSent);
				
				# nettoyage du fichier si notifications envoyées
				if(in_array($artNotification['artId'],$artNewsPosted)) unlink($pendingNotification);
				
				# liste des abonnés
				$file=PLX_ROOT.'plugins/'.__CLASS__.'/'.$this->subscriptions.'/'.$this->subscriptions.'.json';
				$datasSubscriptions = $this->getJsonDatas($file);
				# nombre d'abonnés
				$nbSubscriptions = count($datasSubscriptions);
				
				# delai en minute entre chaque lots
				$delay = $this->getParam('delay') =='' ? 1 	: $this->getParam('delay');
				
				# combien d'envoi par lots ?
				$this->lots = $this->getParam('lots') =='' ? $this->lots 	: $this->getParam('lots');
				
				# Si: 
				# delai passé
				# un fichier de notification
				# un tableau 
				# un abonné 
				# un abonnement validé
				
				if(
				strtotime('-'.$delay.' minutes') > filemtime($file)
				AND file_exists($pendingNotification)
				AND is_array($datasSubscriptions) 
				AND count($datasSubscriptions) > 0 
				AND array_search('1', array_column($datasSubscriptions, 'valid'))>=0
				) {				
					$notification = $this->getLang('L_NOTIFICATION_ON');
					$num = 0;
					$lots = 0;
					foreach($datasSubscriptions as $subscriber => $subK) {
						# update dateSub format for  subscribers imported from MyNewsLetter
						if(strpos($datasSubscriptions[$subscriber]['dateSub'], '-')) $datasSubscriptions[$subscriber]['dateSub'] = $this->updateDateToU($datasSubscriptions[$subscriber]['dateSub']);
						# nettoyage abonnement non validés de + 3mois
						if(strtotime('-3 months') > $datasSubscriptions[$subscriber]['dateSub'] && $datasSubscriptions[$subscriber]['valid'] == '0') {
							unset($datasSubscriptions[$subscriber]);
							$this->saveJsonDatas($file,$datasSubscriptions);
							$nbSubscriptions = count($datasSubscriptions);
							$this->record('unset');
							continue;
						}
						
						# index abonnement
						$num = array_search($subscriber, array_keys($datasSubscriptions))+1;
						
						# si abonnement validé et pas de notification d'article
						if($datasSubscriptions[$subscriber]['lastSent'] != $artNotification['artId'] && $datasSubscriptions[$subscriber]['valid'] == '1' ) {
							# decryptage du mail
							$email = str_replace($this->subscriptions, '',base64_decode($datasSubscriptions[$subscriber]['email']));
							$plxMotor = plxMotor::getInstance();
							$cancel   = '<p><a href="'.$plxMotor->urlRewrite('?'.$this->getParam('url').'&stopNewsLetter='.$datasSubscriptions[$subscriber]['revoque']).'">'.$this->getLang('L_STOP').'</p>';
							#tentative d'envoi
							if($this->sendNewsEmail($email,'Notification de publication du '.date('d-m-Y'),$cancel.$artNotification['publication'])) {
								$datasSubscriptions[$subscriber]['lastSent'] = $artNotification['artId'];
								$this->saveJsonDatas($file,$datasSubscriptions);
								# stats
								$this->record('sent');
								# suivi du lot
								$lots++;
								# Notification dans l'admin
								$notification .='<br> N° '.$num. '/'.$nbSubscriptions.' - lot '.$lots .'/'.$this->lots; 
							}
							# erreur sur envoi
							else {
								$notification .= '<br>'.PHP_EOL.$this->getLang('L_MAIL_ERROR').' '.$num;
								if($num >= $nbSubscriptions && $lots == 0 ) $Notification .= '<br>'.PHP_EOL.$this->getLang('L_ERROR_NO_MAIL_SENT');
							}
							# lot complet
							if($lots >= $this->lots) break;
						}
					}
					if($lots == 0) $notification = $this->getLang('L_MAIL_ALREADY_SENT');
					# dernier abonné ?
					if ($num >= $nbSubscriptions){
						$artNewsPosted[]=trim($artNotification['artId']);
						$this->saveJsonDatas($fileNewsSent,$artNewsPosted);
						unlink($pendingNotification );# destruction du fichier de notification
						$notification .='<br>'.PHP_EOL.$this->getLang('L_ALL_MAIL_SENT');
					}
					echo self::BEGIN_CODE;
				?>
				echo '<p id="msgNews" class="alert green"><?= $notification ?></p>';
				<?php
					echo self::END_CODE;
				}
			}			
		}
		
		/**************************
			*** Fonctions internes ***
		**************************/
		
		/* verifie le format d'une adresse mail
			* Verification via les fonctions de PHP
			*
			* @author	Cyrille G.
		*/
		public function checkEmail($email) {
			if(filter_var($email, FILTER_VALIDATE_EMAIL)){
				return true;
				}else{
				return false;
			}
		}
		
		/* Mets à jour ou créer un fichier de données au format json
			*
			*
		*/
		public function saveJsonDatas($file,$datas) {
			file_put_contents($file, json_encode($datas,true | JSON_PRETTY_PRINT) );	
		}
		
		/* Lit un fichier de données au format json
			*
			* renvoi un tableau
			*
		*/
		public function getJsonDatas($file) {
			if(!file_exists($file)) return false;
			$datas = json_decode(file_get_contents($file),true);	
			return $datas;
		}	
		
		/**
			* Méthode qui ajoute un abonné au  fichier json 
			* Methode appeler depuis la page d'administration
			* @author	Cyrille G.
		**/	
		public function addSubscriber(){
			$this->setParam('method','get','string');
			if(isset($_GET['addSubscriber'])) {				
				$this->saveSubscription();
			}
		}
		
		/* formatage de la date au format locale	
			*
			* time() 
			*
			* PluXml aConf['default_lang']
			*
			* Pluxml aConf['timezone']
			*
			* return locale Date
			*
		*/
		public function timeToLocalDate($time){
			$plxMotor = plxMotor::getInstance();
			$locale = $plxMotor->aConf['default_lang']; // Locale
			if(class_exists('IntlDateFormatter')) {
				$timezone = $plxMotor->aConf['timezone']; // Fuseau horaire
				$format = new IntlDateFormatter($locale,IntlDateFormatter::SHORT,IntlDateFormatter::SHORT,$timezone	);
				$date_locale = $format->format($time);
				return $date_locale;
			}
			else {
				$formats=json_decode( file_get_contents(PLX_PLUGINS.basename(__DIR__).'/lang/country_date_formats.json') );
				$format = $formats->$locale;
				return date($format,$time);
			}
		}
		
		/* formatage d'une date au format 'm-Y' en timestamp	
			*
			* date string
			*
			* timestamp U
			*
		*/
		public function updateDateToU($update) {
			$date = DateTime::createFromFormat('!m-Y', $update);
			return $date->format('U');
		}
		/*
			*
			* enregistre un nouvel abonné
			*
		*/
		public function saveSubscription() {
			$method = $this->getParam('method') == 'get' ? $_GET : $_POST;
			if(isset($method['notifyMe'])) { 
				$email= trim($method['notifyMe']);
				if($this->checkEmail($email)) {	
					$plxMotor = plxMotor::getInstance();
					$mail=base64_encode($email.$this->subscriptions);
					$date=time(); 					
					# valeur lien de désabonnement
					$revoque= bin2hex(random_bytes('16'));
					# etat validation abonnement
					if(!isset($method['valid'])) {$valid='0';} else {$valid='1';}
					# datas
					$datasSubscriptions = json_decode(file_get_contents(PLX_ROOT.'plugins/'.__CLASS__.'/'.$this->subscriptions.'/'.$this->subscriptions.'.json'), true);
					# des datas ?
					if(is_array($datasSubscriptions)) {
						$datasSubscriptions= array_values( array_column($datasSubscriptions, null, 'email') );
						foreach($datasSubscriptions as $element) {
							if($email == str_replace($this->subscriptions, '',base64_decode( $element['email']))) {
								return sprintf($this->getLang('L_SUBSCRIPTION_FOUND'), '<b>'.trim($email).'</b>','<cite>'.$plxMotor->aUsers['001']['name'].'</cite>',$plxMotor->aConf['title'] );
								goto endIt;
								break;
							}
						}					
						end($datasSubscriptions) ;
						# stats abonnement
						$newSubscription= key($datasSubscriptions)+ 1;
						# ajout abonnement
						$_SERVER['HTTP_REFERER'] = isset($_SERVER['HTTP_REFERER']) =='' ? 'none' :$_SERVER['HTTP_REFERER'];
						$datasSubscriptions[$newSubscription]= array('email'=> $mail , 'dateSub'=> $date, 'revoque' => $revoque, 'valid'=> $valid , 'lastSent'=>'0000', 'agent'=> $_SERVER ['HTTP_USER_AGENT'] , 'referent'=>   $_SERVER['HTTP_REFERER']  , 'ip'=>$_SERVER ['REMOTE_ADDR'] );
					}
					else { // premier abonement
						$datasSubscriptions[]= array('email'=> $mail , 'dateSub'=> $date, 'revoque' => $revoque, 'valid'=> $valid , 'lastSent'=>'0000', 'agent'=> $_SERVER ['HTTP_USER_AGENT'] , 'referent'=>   $_SERVER['HTTP_REFERER']  , 'ip'=>$_SERVER ['REMOTE_ADDR'] );	
					}
					# valeur de désabonnement à transmettre
					$this->revoque = $revoque;
					#sauvegarde du fichier
					$this->saveJsonDatas(PLX_ROOT.'plugins/'.__CLASS__.'/'.$this->subscriptions.'/'.$this->subscriptions.'.json', $datasSubscriptions);	
					
					# validation requise
					if(!isset($method['valid']))
					return $this->validBack($email,$revoque);
				}
				else {
					return $this->getLang('L_BAD_MAIL');
				}
			}
			endIt:  // si pas de datas	
		}
		
		/* envoi d'un mail
			*
			* utilise la configuration de PluXml
			*
			* fonction mail() native ou PHPMailer
			*
			* author G-Cyrillus
			*
		*/
		public function sendNewsEmail($email,$subject,$body) {
			$plxMotor = plxMotor::getInstance();
			if(empty($plxMotor->aConf['email_method']) or $plxMotor->aConf['email_method'] == 'sendmail' or !method_exists(plxUtils::class, 'sendMailPhpMailer')) {
				# fonction mail() intrinsèque à PHP
				return plxUtils::sendMail('', '', $email, $plxMotor->aConf['title'].': '.$subject, $body, $contentType="html");
				} else {
				# On utilise PHPMailer
				return plxUtils::sendMailPhpMailer($plxMotor->aConf['title'], $plxMotor->aConf['smtp_username'], $email, $plxMotor->aConf['title'].': '.$subject, $body, true, $plxMotor->aConf, false);
			}
		}
		
		/**
			* methode qui envoi un mail de demande de confirmation d'abonnement 
			* 
			* Verifie que le possesseur de l'adresse mail est bien consentant
			*
			* @author Cyrille G.
		**/	
		public function validBack($email,$revoque){
			$plxMotor = plxMotor::getInstance();
			$validate = $plxMotor->urlRewrite('?'.$this->getParam('url').'&validNewsLetter='.$revoque);
			$cancel   = $plxMotor->urlRewrite('?'.$this->getParam('url').'&stopNewsLetter='.$revoque);
			$body = sprintf($this->getLang('L_SUBSCRIPTION_VALIDATE'),  $email , $plxMotor->aConf['title'], $validate , $cancel , $plxMotor->aUsers['001']['name'], $plxMotor->aConf['title']);
			# envoi d'un courriel 
			$this->sendNewsEmail($email,sprintf($this->getLang('L_VALIDATE_SUBSCRIPTION'),$plxMotor->aConf['title']),$body);
			#affichage message (pas de test d'erreur!!)
			return sprintf($this->getLang('L_SUBSCRIPTION_PENDING'), '<b>'.$email.'</b>' , '<a href="'.$cancel.'">'.$this->getLang('L_CANCEL_SUBSCRIPTION').'</a>.', '<cite>'.$plxMotor->aUsers['001']['name'].'</cite>');	
		}
		
		/**
			* Méthode qui valide un abonné au  fichier json
			*
			* @author	Cyrille G.
		**/	
		public function valid(){
			$method = 'get';
			$done=false;
			$plxMotor = plxMotor::getInstance();
			$datasSubscriptions = $this->getJsonDatas(PLX_ROOT.'plugins/'.__CLASS__.'/'.$this->subscriptions.'/'.$this->subscriptions.'.json');
			foreach($datasSubscriptions as $key=>$value){
				if( $value['revoque'] == $_GET['validNewsLetter']) {
					$email = str_replace($this->subscriptions, '',base64_decode( $datasSubscriptions[$key]['email']));
					if($value['valid'] == 1 ) {
						return sprintf($this->getLang('L_SUBSCRIPTION_VALIDATED'), $email, '<cite>'.$plxMotor->aUsers['001']['name'].'</cite>');
						$done=true;
						break;
					}
					$validate = $plxMotor->urlRewrite('?'.$this->getParam('url').'&validNewsLetter='.$datasSubscriptions[$key]['revoque']);
					$cancel   = $plxMotor->urlRewrite('?'.$this->getParam('url').'&stopNewsLetter='.$datasSubscriptions[$key]['revoque']);
					$body	  = sprintf($this->getLang('L_SUBSCRIPTION_ACTIVE'), '<b>'.$email.'</b>', $cancel ,$plxMotor->aUsers['001']['name'], $plxMotor->aConf['title']);
					$datasSubscriptions[$key]['valid']='1';
					$this->saveJsonDatas(PLX_ROOT.'plugins/'.__CLASS__.'/'.$this->subscriptions.'/'.$this->subscriptions.'.json', $datasSubscriptions);
					return $body;
					$done=true;
					break;
				}
			}
			if(!$done) return $this->getLang('L_SUBSCRIPTION_NOT_FOUND') ;								
		}
		
		/**
			* Méthode qui retire un abonné au  fichier json
			*
			* @author	Cyrille G.
		**/	
		public function revoque(){
			$method = 'get';
			$done=false;
			$plxMotor = plxMotor::getInstance();
			$datasSubscriptions = $this->getJsonDatas(PLX_ROOT.'plugins/'.__CLASS__.'/'.$this->subscriptions.'/'.$this->subscriptions.'.json');
			foreach($datasSubscriptions as $key=>$value){
				if( $value['revoque'] == $_GET['stopNewsLetter']) {
					unset($datasSubscriptions[$key]);
					$this->saveJsonDatas(PLX_ROOT.'plugins/'.__CLASS__.'/'.$this->subscriptions.'/'.$this->subscriptions.'.json', $datasSubscriptions);
					$this->record('defec');
					return $this->getLang('L_UNSUBSCRIB');
					$done=true;
				}
			}
			if(!$done)  return $this->getLang('L_SUBSCRIPTION_NOT_FOUND');
		}
		
		/**
			* methode qui incremente les stats
			*
			* @author Cyrille G.
		**/	
		public function record($what){				
			$fileStat = PLX_ROOT.'plugins/'.basename(__DIR__).'/'.$this->subscriptions.'/infosStat.json';	
			if(!file_exists($fileStat)) {
				touch($fileStat);
				$sent= 0;
				$retours=0;
				$stats= array('sent'=> 0 , 'retour' => 0 , 'defec' => 0 , 'unset' => 0 , 'lastDate' => time());
			}
			else {
				$stats =  $this->getJsonDatas($fileStat);			
			}
			$stats['sent'] 		= $stats['sent'];
			$stats['retour'] 	= $stats['retour'];
			$stats['defec'] 	= $stats['defec'];	
			$stats['unset'] 	= $stats['unset'];	
			$stats['lastDate'] 	= $stats['lastDate'];
			
			# enregistrement retour lien des mailing
			if($what=='visit') {
				$stats['lastDate'] = $stats['lastDate'];
				$stats['retour']++;		
			}
			# enregistrement envois mails
			if($what=='sent') {
				$stats['sent']++;
				$stats['lastDate'] = time();
			}
			# enregistrement desabonements
			if($what=='defec') {
				$stats['defec']++;
			}
			# enregistrement nettoyages
			if($what=='unset') {
				$stats['unset']++;
			}
			# sauvegarde
			$this->saveJsonDatas($fileStat,$stats);
		}
		
		/*
			* getsubscribers
			*
			* Affiche les abonnés dans la page d'administration
			*
			* moderation des abonnement
			*
			* Ajout/effacement d'un abonement.
			*
		*/
		public function getsubscribers() {	echo "
			<script>
				const L_RETRY_VALID_MAIL =\"".$this->getLang('L_RETRY_VALID_MAIL')."\";
				const ERROR_MESSAGE =\"".$this->getLang('L_NO_SUBSCRIPTION')."\";
				const L_DELETED = '".$this->getLang('L_DELETED')."';
				const L_ERROR_DEL_SUB = '".$this->getLang('L_ERROR_DEL_SUB')."';
				const L_UNKNOWN ='".$this->getLang('L_UNKNOWN')."';
				const NEWSMAIL = '".$this->getParam('from')."';
				const TODAY ='".time()."';
				const TIME =  new Date(TODAY*1000);
				let mn = ('0' + TIME.getMinutes()).slice(-2)
				let h = TIME.getHours();
				let d = ('0' + (TIME.getDate())).slice(-2);
				let m = ('0' + (TIME.getMonth() + 1)).slice(-2);
				let Y = TIME.getFullYear()
				const DATESUB = d+'/'+m+'/'+Y+' '+h+':'+mn;
				const L_NONE1 ='".L_NONE1 ."';
				const L_NEW ='".$this->getLang('L_NEW')."';
				const L_YES ='".L_YES."';
				const L_NO ='".L_NO."';
				const PLX_ROOT ='".PLX_ROOT."';
			</script>
				";
				# parcours des abonnements 
				$datas ='
				<table id="suscribers">
					<thead>
						<tr><th>Courriel</th><th>valide</th><th>Date subscription</th><th>Id Notification</th><th>IP</th><th></th>
						</tr>
					</thead>
					<tbody>
				';
			$datasSubscriptions = json_decode(file_get_contents(PLX_ROOT.'plugins/'.__CLASS__.'/'.$this->subscriptions.'/'.$this->subscriptions.'.json'), true);
			$valid=  L_YES;
			
			# y a t-il des abonnements, 
			if(is_array($datasSubscriptions) AND count($datasSubscriptions) > 0) { //si oui on continue, il y a au moins un abonné
			
				foreach($datasSubscriptions as $records =>$v) {
					$courriel = str_replace($this->subscriptions, '',base64_decode( $v['email']));
					$valid= $v['valid'] =='0' ?  L_NO : L_YES;
					$dateSub =$this->timeToLocalDate($v['dateSub']) == '' ? $v['dateSub'] : $this->timeToLocalDate($v['dateSub']);
					$lastSent= $v['lastSent'];
					$ip=!isset($v['ip']) ? '?' : $v['ip'] ;
					$datas .='
						<tr><th>'.$courriel.'</th><td>'.$valid.'</td><td>'.$dateSub.'</td><td>'.$lastSent.'</td><td>'.$ip.'</td><td><a  data-revoque=\''.$v['revoque'].'\'>'.$this->getLang('L_DELETE').'</a></th></tr>';
				}
			}
			else {
				$datas .= '<tr><td></td><td colspan="5">'.$this->getLang('L_NO_DATA').'</td></tr>';
			}
				$datas .='
					</tbody>
					<tfoot><tr><td><input type="text" id="courriel"></td><td>'.$valid.'</td><td>'.$this->timeToLocalDate(time()).'</td><td>xxxx</td><td colspan=2 style="text-align:center"><a id="add">'.$this->getLang('L_ADD_SUBSCRIBER').'</a></td></tr></tfoot>
				</table>';
				echo $datas;
		}
		
	}
